#!/bin/python
# -*- coding: utf-8 -*-

from PyQt4.QtGui import QWidget
from PyQt4.QtGui import QIcon
from PyQt4.QtGui import QMessageBox
from PyQt4.QtGui import QApplication
from threading import Thread, Lock
from time import sleep
import sys
import settings
import vk_api
import os
from vk_api import LoginDialog
import shutil

app = QApplication(sys.argv)

def cache_clear():
    shutil.rmtree(settings.audiocache_path)
    os.mkdir(settings.audiocache_path[:len(settings.audiocache_path)-1])

import wigets
wigets.app = app
if os.path.isfile(settings.lockpath):
    reply = QMessageBox.warning(None, u'Внимание',
            u"Вероятно, приложение уже запущено. Такое может случится, если в предыдущей сессии оно было закрыто аварийно. Если вы уверены, что приложение не запущено нажмите YES", QMessageBox.Yes | 
            QMessageBox.No, QMessageBox.No)
    if reply == QMessageBox.No:
        sys.exit()
    else:
        os.remove(settings.lockpath)
cache_clear()
lock = file(settings.lockpath,'w')
lock.close()
vk_api.app = app
if os.path.isfile(settings.tokenpath):
    tokenfile = open(settings.tokenpath,'r')
    token = tokenfile.readline()
    tokenfile.close()
    vk_api.vk = vk_api.VK()
    vk_api.vk.token = token
    vk_api.vk.myid = vk_api.vk.get_my_id()
    vk_api.vk.get_friends(vk_api.vk.myid)
    vk_api.vk.get_friends_online(vk_api.vk.myid)
else:
    loginDialog = LoginDialog()
    #loginDialog.show()
    loginDialog.exec_()
    
if vk_api.vk!=None:
    dialog = wigets.DialogWidget()
    dialog.showMaximized()
    dialog.setWindowTitle("VK-LITE")
    app.setWindowIcon(QIcon(settings.images_path+"icon-mini.png"))
sys.exit(app.exec_())