import platform
import os


path = os.path.dirname(os.path.abspath(__file__))
OS = "Linux"
sys_dirsplitter = "/"
if platform.system()=='Windows':
    OS = "Windows"
    sys_dirsplitter='\\'
lastsplit = path[:len(path)-1].rfind(sys_dirsplitter)

pre_path = path+sys_dirsplitter
if not path.find("library.zip")==-1:
    pre_path = path[:lastsplit+1]
    path = pre_path
lockpath = path+sys_dirsplitter+'temp\\lock'
tokenpath = path+sys_dirsplitter+'temp\\token'
loginpath = path+sys_dirsplitter+'temp\\last_login'
group_id = '74888890'
version = '0.3'

soundpath = pre_path+'sounds'+sys_dirsplitter
images_path = pre_path+'images'+sys_dirsplitter
config_path = pre_path+'configs'+sys_dirsplitter
temppath = pre_path+'temp'+sys_dirsplitter
musicpath = pre_path+'music'+sys_dirsplitter

audiocache_path = pre_path+'audiocache'+sys_dirsplitter
if OS=='Linux':
    lockpath = os.getenv('HOME')+'/.vklite/temp/lock'
    tokenpath = os.getenv('HOME')+'/.vklite/temp/token'
    loginpath = os.getenv('HOME')+'/.vklite/temp/last_login'
    config_path = os.getenv('HOME')+'/.vklite/configs/'
    audiocache_path = os.getenv('HOME')+'/.vklite/audiocache/'
    temppath = os.getenv('HOME')+'/.vklite/temp/'
    if not os.path.isdir(os.getenv('HOME')+'/.vklite'):
        os.mkdir(os.getenv('HOME')+'/.vklite')
    if not os.path.isdir(temppath):
        os.mkdir(temppath[:len(temppath)-1])
if not os.path.isdir(audiocache_path):
    os.mkdir(audiocache_path[:len(audiocache_path)-1])
if not os.path.isdir(temppath):
    os.mkdir(temppath[:len(temppath)-1])
if not os.path.isdir(config_path):
    os.mkdir(config_path[:len(config_path)-1])
invisepath = temppath+sys_dirsplitter+'invise'        
sound_config = config_path+'sound.conf'
