# -*- coding: utf-8 -*-
'''
Created on 16 июля 2014 г.

@author: passat
'''
from PyQt4.QtGui import QWidget
from PyQt4.QtGui import QLabel
from PyQt4.QtGui import QVBoxLayout
from PyQt4.QtGui import QHBoxLayout
from PyQt4.QtGui import QListWidget
from PyQt4.QtGui import QListWidgetItem
from PyQt4.QtGui import QPixmap
from PyQt4.QtGui import QSystemTrayIcon
from PyQt4.QtGui import QAction
from PyQt4.QtGui import QMenu
from PyQt4.QtGui import QColor
from PyQt4.QtGui import QApplication
from PyQt4.QtGui import QDesktopWidget
from PyQt4.QtGui import QScrollArea
from PyQt4.QtGui import QMessageBox
from PyQt4.QtGui import QIcon
from PyQt4.QtGui import QLineEdit
from PyQt4.QtGui import QFileDialog
from PyQt4.QtGui import QRadioButton
from PyQt4.QtGui import QPushButton
from PyQt4.QtGui import QDialog
from PyQt4.QtGui import QShortcut
from PyQt4.QtGui import QMovie
import StringIO
import urllib2
from threading import Thread, Lock
from time import sleep
import sys
import settingsDialog
import sound_notifier
from sound_notifier import MusicPlayer
import urllib
import vk_api
import webbrowser
import os
from PyQt4 import QtCore
from PyQt4 import Qt
from PyQt4.Qt import QSize, pyqtSignal, QUrl, QSizePolicy, QKeySequence


import platform
import settings
import pygame
import shutil



app = None

def songname_to_correct_filename(title):
    title.replace(',',' ')
    title.replace('.','_')
    title.replace('?','_')
    title.replace('\\','_')
    title.replace('/','_')
    title.replace(':','_')
    title.replace('<','_')
    title.replace('>','_')
    title = title+'.mp3'
    return title

def urlfinder(label):
    starthref = '< a href="'
    text = unicode(label.text())
    linkstart = text.find('http')
    if linkstart==-1:
        return label
    textlist = []
    while linkstart>-1:
        textlist.append(text[:linkstart])
        text = text[linkstart:]
        endlink = text.find(' ')
        endlink2 = text.find('<')
        if endlink!=-1 and endlink2<endlink:
            endlink = endlink2
        if endlink==-1:
            endlink = len(text)
        link = text[:endlink]
        endref = '">'+link+'< /a>'
        link = starthref+link+endref
        textlist.append(link)
        text = text[endlink:]
        linkstart = text.find('http')
        if linkstart==-1:
            textlist.append(text)
            break
    result=''
    for elem in textlist:
        result = result+elem    
    label.setText(result)
    label.setOpenExternalLinks(True)
    return label

class Downloader(QtCore.QThread):
    
    def __init__(self,mv,url,filepath):
        super(Downloader, self).__init__(mv)
        self.url = url
        self.filepath = filepath
        self.site = urllib.urlopen(self.url)
        meta = self.site.info()
        self.size = int(meta.getheaders("Content-Length")[0])
        
    def run(self):    
        f = open(self.filepath,'wb',0)
        f.write(self.site.read())
        self.site.close()
        f.close()
        
        
        
    
               
class AboutW(QDialog):
    def __init__(self):
        QDialog.__init__(self)
        vbox = QVBoxLayout()
        header = QLabel(u'<b>VK-LITE v'+settings.version+'</b>')
        logo = QLabel()
        logo.setPixmap(QPixmap(settings.images_path+'logo.png'))
        vbox.addWidget(logo)
        vbox.addWidget(header)
        text = QLabel(u'Программа обмена сообщениями через социальную сеть ВКонтакте.<br><b>Разработчик</b>: Струнин Андрей<br>< a href="http://bitbucket.org/acrap/vk_lite">Вики приложения< /a>')
        contacts = QLabel(u'email:acrap@mail.ru<br>< a href="http://vk.com/acrap">Андрей Струнин ВКонтакте< /a><br>< a href="http://vk.com/vk_lite_app">Группа приложения ВКонтакте< /a>')
        contacts.setOpenExternalLinks(True)
        contacts.setWordWrap(True)
        text.setFixedWidth(logo.sizeHint().width())
        contacts.setFixedWidth(logo.sizeHint().width())
        text.setWordWrap(True)
        vbox.addWidget(text)
        vbox.addWidget(contacts)
        self.setWindowTitle(u'О программе')
        self.setLayout(vbox)
        
class AttachWidget(QWidget):
    def __init__(self, parent,attach):
        super(AttachWidget, self).__init__(parent)
        self.vbox = QVBoxLayout()
        self.type = 'unknown'
        self.setLayout(self.vbox)
        self.show_full = QPushButton(u'Воспроизвести')
        self.show_full.clicked.connect(self.show_full_clicked)
        self.player = None
        if attach['type']=='photo':
            self.__attach_is_photo(attach)
            return 
        if attach['type']=='audio':
            self.__attach_is_audio(attach)
            return
        if attach['type']=='video':
            self.__attach_is_video(attach)
            return
        if attach['type']=='doc':
            self.__attach_is_doc(attach)
            return
    
            
    def show_full_clicked(self):
        self.br.load(self.url)
        
        
    def __attach_is_video(self,attach):
        self.type = 'video'
        adv = attach['video']
        hbox = QHBoxLayout()
        pic = QLabel()
        pix = QPixmap(settings.images_path+"video-icon.png")
        pic.setPixmap(pix)
        pic.setFixedWidth(50)
        hbox.addWidget(pic)
        title_label = QLabel(adv['title'])
        hbox.addWidget(title_label)
        video_id = str(adv['owner_id'])+'_'+str(adv['vid'])
        self.link = vk_api.vk.get_video_link_by_id(video_id)
        if self.link==False:
            pic2 = QLabel()
            pix2 = QPixmap(settings.images_path+"error.png")
            pic2.setPixmap(pix2)
            hbox.addWidget(pic2)
            hbox.addWidget(QLabel(u'ОШИБКА'))
            self.vbox.addLayout(hbox)
            return
        seeButton = QPushButton(u'Открыть')
        seeButton.clicked.connect(self.seeInBrowser)
        hbox.addWidget(seeButton)
        self.vbox.addLayout(hbox)
        
    def closeEvent(self, event):
        if self.type=='audio':
            if self.player!=None:
                self.player.stop()
                
    def song_downloaded(self):
        self.player = MusicPlayer(self,self.songpath,self.audio_tittle)
        self.hbox.addWidget(self.player)
        self.seeButton.setVisible(False)
                 
    def seeInBrowser(self):
        if self.type=='audio':
            self.seeButton.setText(u'Загружается')
            self.seeButton.update()
            QApplication.processEvents()
            sleep(0.5)
            
            if os.path.isfile(self.songpath):
                player = MusicPlayer(self,self.songpath,self.audio_tittle)
                self.hbox.addWidget(player)
                self.seeButton.setVisible(False)
                return
            downloader = Downloader(self,self.link,self.songpath)
            downloader.start()
            downloader.finished.connect(self.song_downloaded)
            return
        if self.link:
            webbrowser.open(self.link)
    def __attach_is_doc(self,attach):
        adv = attach['doc']
        url = adv['url']
        ext =adv['ext'] 
        if ext=='gif':
            data = urllib.urlopen(url).read()
            tempgif = open(settings.temppath+'tempgif.gif','wb')
            tempgif.write(data)
            tempgif.close()
            GifPlayer = ImagePlayer(settings.temppath+'tempgif.gif')
            self.vbox.addWidget(GifPlayer)
        if ext=='jpg' or ext=='png'or ext=='bmp' or ext=='jpeg':
            data = urllib.urlopen(url).read()
            photo_box = QLabel()
            pixmap = QPixmap()
            pixmap.loadFromData(data)
            photo_box.setPixmap(pixmap)
            self.vbox.addWidget(photo_box)
        hbox = QHBoxLayout()
        self.title = adv['title']
        hbox.addWidget(QLabel(self.title))
        save_docB = QPushButton(u"Сохранить")
        hbox.addWidget(save_docB)
        save_docB.clicked.connect(self.savedoc)
        self.link = url
        self.vbox.addLayout(hbox)
            
    def savedoc(self):
        docname = unicode(self.title)
        fileName = QFileDialog.getSaveFileName(self,u"Сохранить песню",docname,"mp3 files (*.mp3);;All Files (*)")
        if fileName!='':
            file = open(fileName,'w')
            data = urllib.urlopen(self.link).read()
            file.write(data)
            
    def __attach_is_photo(self,attach):
        self.type ='photo'
        photo_box = QLabel()
        adv = attach['photo']
        src_big = adv['src_big']
        data = urllib.urlopen(src_big).read()
        pixmap = QPixmap()
        pixmap.loadFromData(data)
        photo_box.setPixmap(pixmap)
        self.vbox.addWidget(photo_box)
        
    def __attach_is_audio(self,attach):
        self.type ='audio'
        self.hbox = QHBoxLayout()
        adv = attach['audio']
        self.audio_tittle = adv['performer']+"-"+adv['title']
        audio_info = QLabel(self.audio_tittle)
        self.link = adv['url']
        split_i = self.link.find('?')
        if split_i>0:
            self.link = self.link[:split_i]
        if settings.OS=='Linux':
            self.songpath = settings.audiocache_path+songname_to_correct_filename((self.audio_tittle).encode('utf-8'))
        else:
            self.songpath = settings.audiocache_path+songname_to_correct_filename((self.audio_tittle))
        pixmap = QPixmap(settings.images_path+"music-icon.png")
        audio_pic = QLabel()
        audio_pic.setPixmap(pixmap)
        audio_pic.setFixedWidth(50)
        self.hbox.addWidget(audio_pic)
        self.hbox.addWidget(audio_info)
        self.seeButton = QPushButton(u'Воспроизвести')
        self.hbox.addWidget(self.seeButton)
        self.seeButton.setFixedWidth(170)
        self.seeButton.clicked.connect(self.seeInBrowser)
        self.vbox.addLayout(self.hbox)
        if os.path.isfile(self.songpath):
            self.seeInBrowser()
        
        
        
class AttachViewer(QDialog):
    
    def closeEvent(self, event):
        try:
            if len(self.atlist)>0:
                for elem in self.atlist:
                    elem.close()
        except:
            pass
                
    def __init__(self, parent,mid):
        super(AttachViewer, self).__init__(parent)
        mess_dic = vk_api.vk.get_message_by_id(mid)
        mess_dic = mess_dic[1]
        mostL = QVBoxLayout()
        self.vbox = QVBoxLayout()
        self.text = QLabel()
        self.setLayout(mostL)
        self.text.setText(mess_dic['body'])
        self.text = urlfinder(self.text)
        self.text.setWordWrap(True)
        self.vbox.addWidget(self.text)
        self.setWindowTitle(u"Сообщение")
        mostL.addLayout(self.vbox)
        try:
            mess_dic['attachments']
        except:
            return
        scroll = QScrollArea()
        w = QWidget()
        vbox = QVBoxLayout()
        w.setLayout(vbox)
        scroll.setWidget(w)
        self.vbox.addWidget(scroll)
        max_width = 0
        summ_height = self.text.sizeHint().height()+50
        self.atlist =[]
        for attach in mess_dic['attachments']:
            if attach['type']=='wall':
                attachs = attach['wall']
                text = attachs['text']
                textLabel = QLabel(u'<b>Запись на стене:</b><br>'+text)
                textLabel = urlfinder(textLabel)
                textLabel.setWordWrap(True)
                vbox.addWidget(textLabel)
                sh = textLabel.sizeHint()
                summ_height = summ_height+sh.height()+20
                if sh.width()>max_width:
                    max_width = sh.width()+50
                try:
                    attachs = attachs['attachments']
                except:
                    continue
                for ats in attachs:
                    at = AttachWidget(self,ats)
                    self.atlist.append(at)
                    _size = at.sizeHint()
                    summ_height = summ_height+_size.height()+20
                    if _size.width()>max_width:
                        max_width = _size.width()+50
                    vbox.addWidget(at)
                continue
            at = AttachWidget(self,attach)
            self.atlist.append(at)
            _size = at.sizeHint()
            summ_height = summ_height+_size.height()+20
            if _size.width()>max_width:
                max_width = _size.width()+50
            vbox.addWidget(at)
        screen = QDesktopWidget().screenGeometry()
        scroll.setWidgetResizable(True)
        if summ_height>(screen.height()-50):
            self.setFixedHeight(screen.height()-50)
        else:
            self.setFixedHeight(summ_height)
        self.setFixedWidth(max_width)  
        
class Message():
    def __init__(self,message):
        message = unicode(message)
        splitter_mid = message.find('|')
        self.id = message[:splitter_mid]
        splitter = message.find('-')
        splitter_attach = message.find(' $ATTACH')
        self.haveAttach = False
        self.author = message[splitter_mid+1:splitter-1]
        if splitter_attach!=-1:
            self.text = message[splitter + 1:splitter_attach]
            self.haveAttach = True
            self.attachs = message[splitter_attach:]
        else:
            self.text = message[splitter + 1:]
        

class MessageWidget(QWidget):
    def __init__(self, parent=None, message=None):
        QWidget.__init__(self, parent)
        self.id = message.id
        self.author = message.author
        self.text = message.text
        self.textLabel = QLabel("<b>" + self.author + ":    </b>" + self.text)
        self.textLabel.setWordWrap(True)
        self.textLabel.update()
        hbox = QHBoxLayout()
        self.setLayout(hbox)
        hbox.addWidget(self.textLabel)
        if message.haveAttach:
            if message.attachs.find('AUDIO')!=-1:
                attachLabel = QLabel()
                attachLabel.setFixedWidth(50)
                attachLabel.setPixmap(QPixmap(settings.images_path+"music-icon.png"))
                hbox.addWidget(attachLabel)
            if message.attachs.find('PHOTO')!=-1:
                attachLabel = QLabel()
                attachLabel.setPixmap(QPixmap(settings.images_path+"photo-icon.png"))
                attachLabel.setFixedWidth(50)
                hbox.addWidget(attachLabel)
            if message.attachs.find('WALL')!=-1:
                attachLabel = QLabel()
                attachLabel.setPixmap(QPixmap(settings.images_path+"wall-icon.png"))
                attachLabel.setFixedWidth(50)
                hbox.addWidget(attachLabel)
            if message.attachs.find('VIDEO')!=-1:
                attachLabel = QLabel()
                attachLabel.setPixmap(QPixmap(settings.images_path+"video-icon.png"))
                attachLabel.setFixedWidth(50)
                hbox.addWidget(attachLabel)
            if message.attachs.find('DOC')!=-1:
                attachLabel = QLabel()
                attachLabel.setPixmap(QPixmap(settings.images_path+"doc-icon.png"))
                attachLabel.setFixedWidth(50)
                hbox.addWidget(attachLabel)                 
        #self.textLabel.setStyleSheet("border: 1px solid gray");
        #self.setStyleSheet("border: 1px solid gray"); 
         
class ContactWidget(QWidget):
    totalUnread = 0
    onlinePixmap = QPixmap(settings.images_path+'online.png')
    offlinePixmap = QPixmap(settings.images_path+'offline.png')
    
    
    def __init__(self, parent=None, name="sample", id="0"):
        '''
        Constructor
        '''
        QWidget.__init__(self, parent)
        self.onlineIcon = QLabel()
        self.__online = False
        self.messages_loaded = False
        self.messages = []
        hbox = QHBoxLayout()
        index = name.rfind("*#") 
        if index==-1:
            self.name = name
            self.set_as_offline()
        else:
            self.name = name[:index]
            self.set_as_online()
        self.id = id
        self.unread = 0
        self.NameLabel = QLabel(self.name)
        self.allMsgLoaded = False
        self.NameLabel.setFixedWidth(225)
        self.UnreadCounter = QLabel()
        self.UnreadCounter.setFixedWidth(25)
        self.onlineIcon.setPixmap(ContactWidget.offlinePixmap)
        hbox.addWidget(self.onlineIcon)
        hbox.addWidget(self.NameLabel)
        hbox.addWidget(self.UnreadCounter)
        self.setLayout(hbox)
        
      
    def is_online(self):
        return self.__online
    def set_as_online(self):
        if self.is_online():
            return
        self.onlineIcon.setPixmap(ContactWidget.onlinePixmap)
        self.__online = True
    def set_as_offline(self):
        if not self.is_online():
            return
        self.onlineIcon.setPixmap(ContactWidget.offlinePixmap)
        self.__online = False 
    
    def message_exist(self,message):
        message = unicode(message)
        splitter_index = message.find("|")
        msg_id = message[:splitter_index]
        for msg in self.messages:
            if msg_id==msg.id:
                return True
        return False
    
    def add_message_to_end(self,message):
        if self.message_exist(message):
            return False
        msg = Message(message)
        if not msg.id==vk_api.vk.myid:
            #play sound
            #DialogWidget.beep.play()
            pass
        self.messages.append(msg)
        return True
    
    def add_message(self, message):
        if self.message_exist(message):
            return False
        msg = Message(message)
        if not msg.id==vk_api.vk.myid:
            #play sound
            
            pass
        self.messages.insert(0,msg)
        return True

    def load_messages(self):
        if self.messages_loaded:
            return
        key = self.id
        if key < 0:
            return
        messages = vk_api.vk.get_message_history(key)
        mes_len = len(messages) - 1
        if mes_len<49:
            self.allMsgLoaded = True
        for i in range(0, mes_len):
            index = i
            message = messages[index]
            if self.message_exist(message):
                continue
            msg = Message(message)
            self.messages.append(msg)
        self.messages_loaded = True
    
    def load_old_messages(self,offset):
        old_messages = []
        key = self.id
        if key < 0:
            return
        messages = vk_api.vk.get_message_history(key,offset)
        mes_len = len(messages) - 1
        if mes_len<49:
            self.allMsgLoaded = True
        self.old_loaded = mes_len +1
        for i in range(0, mes_len):
            index = i
            message = messages[index]
            if self.message_exist(message):
                continue
            msg = Message(message)
            old_messages.append(msg)
        new_mes = self.messages
        self.messages = []

        for elem in new_mes:
            self.messages.append(elem)
        for elem in old_messages:
            self.messages.append(elem)
        
             
    def add_unread(self):
        self.unread = self.unread+1
        self.UnreadCounter.setText("<b>" + str(self.unread) + "</b>")
        ContactWidget.totalUnread = ContactWidget.totalUnread +1
        DialogWidget.unreadRb.setText(u"Непрочитанные ("+str(ContactWidget.totalUnread)+")")
        DialogWidget.fill_contactbox()
        
        
    def reset_unread(self):
        ContactWidget.totalUnread = ContactWidget.totalUnread - self.unread
        DialogWidget.unreadRb.setText(u"Непрочитанные ("+str(ContactWidget.totalUnread)+")") 
        self.UnreadCounter.setText("")
        vk_api.vk.mark_dialog_read(self.id)
        self.unread=0
        
   
class ImagePlayer(QWidget):
    def __init__(self, filename, parent=None):
        QWidget.__init__(self, parent)
 
# Load the file into a QMovie
        self.movie = QMovie(filename, QtCore.QByteArray(), self)
        size = self.movie.scaledSize()
        self.setGeometry(200, 200, size.width(), size.height())
        self.movie_screen = QLabel()
        # Make label fit the gif
        self.movie_screen.setSizePolicy(QSizePolicy.Expanding, QSizePolicy.Expanding)
        self.movie_screen.setAlignment(QtCore.Qt.AlignCenter)
        # Create the layout
        main_layout = QVBoxLayout()
        main_layout.addWidget(self.movie_screen)
        self.setLayout(main_layout)
        # Add the QMovie object to the label
        self.movie.setCacheMode(QMovie.CacheAll)
        self.movie.setSpeed(100)
        self.movie_screen.setMovie(self.movie)
        self.movie.start()

class OnlineRefreshThread(QtCore.QThread):
    onlineStatusUpdated = QtCore.pyqtSignal()
    def __init__(self):
        QtCore.QThread.__init__(self)
    def run(self):
        while True:
            sleep(30)
            vk_api.vk.refresh_online_status()
            self.onlineStatusUpdated.emit()
        
class SetOnlineThread(QtCore.QThread):
    
    def __init__(self):
        QtCore.QThread.__init__(self)
        self.online = False
        
    def run(self):
        while True:
            if self.online:
                data_dic = {}
                vk_api.vk.send_to_api("account.setOnline", data_dic)
                time = 60*15
                sleep(time)
            else:
                sleep(10)
                            
class DialogThread(QtCore.QThread):
    haveUnreadSignal = QtCore.pyqtSignal(int,str)
    def __init__(self):
        QtCore.QThread.__init__(self)
    
    def __del__(self):
        self.wait()

    def check_mail(self):
        answer = vk_api.vk.get_unread_messages()
        if not answer:
            sleep(1)
            return
        count = answer[0]
        if not count > 0:
            sleep(1)
            return
        for i in range(1, count+1):
            userdic = answer[i]
            id = userdic['uid']
            mid = userdic['mid']
            body = userdic['body']
            try:
                userdic['chat_id']
                continue
            except:
                pass
            try:
                contact = DialogWidget.contactWidgetDic[id]
                name = contact.name
            except:
                return
            message = str(mid)+"|"+name+" - "+body
            try:
                attachlist = userdic['attachments']
                message = message + " $ATTACH:"
                for attach in attachlist:
                    if attach['type'] == 'audio':
                        message = message + " AUDIO"
                    if attach['type'] =='photo':
                        message = message + " PHOTO"
                    if attach['type'] =='wall':
                        message['type'] = message + " WALL"
                    if attach['type'] =='doc':
                        message['type'] = message + " DOC"
            except:
                pass
            if contact.message_exist(message):
                return
            self.haveUnreadSignal.emit(int(id),message)
            
            
    def run(self):
        while True:
            self.check_mail()
            sleep(1)    
               
class DialogWidget(QWidget):
    '''
    classdocs
    '''
    dialog = None
    muteIcon = QIcon(settings.images_path+'mute.png')
    noMuteIcon = QIcon(settings.images_path+'no_mute.png')
    contact_box = QListWidget()
    contactWidgetDic = {}
    message_list = QListWidget()
    input_text = QLineEdit()
    filterText = QLineEdit()
    onlineRb = QRadioButton(u'Онлайн')
    allRb = QRadioButton(u'Все')
    unreadRb = QRadioButton(u"Непрочитанные (0)")
    send_button = QPushButton(u"Отправить")
    messages_dic = {}
    contact_keys = []
    current_key = -1
    
    def get_contact_by_id(self, id):
        for contact in DialogWidget.contacts:
            if contact.id == id:
                return contact
        return False
    
    
    def have_unread_slot(self,uid_key,message):
        contact = DialogWidget.contactWidgetDic[uid_key]
        if not self.showed:
            self.trayIcon.setIcon(QIcon(settings.images_path+"icon-mini_unread.png"))
        if contact.message_exist(message):
            return
        contact.add_message(message)
        msg = Message(message)
        sound_notifier.SoundNotifier.msgNotify(msg.author, msg.text)
        if str(DialogWidget.current_key) == str(uid_key):
            if self.showed:
                DialogWidget.refresh_msg_list()
                vk_api.vk.mark_dialog_read(contact.id)
            else:
                contact.add_unread()
        else:
            contact.add_unread()
        
        
    
    
    def init_contacts(self):
        DialogWidget.contacts = []
        target_dic = vk_api.vk.friends
        DialogWidget.contact_box.clear()
        item = QListWidgetItem()
        item.setSizeHint(QSize(0, 40))
        contact = ContactWidget(None,u'Я', vk_api.vk.myid)
        DialogWidget.contactWidgetDic[vk_api.vk.myid] = contact
        DialogWidget.contacts.append(contact)
        DialogWidget.contact_box.addItem(item)
        DialogWidget.contact_box.setItemWidget(item, contact)
        for key in target_dic:
            item = QListWidgetItem()
            contact = ContactWidget(None, target_dic[key], key)
            item.setSizeHint(contact.sizeHint())
            DialogWidget.contactWidgetDic[key] = contact
            DialogWidget.contacts.append(contact)
            DialogWidget.contact_box.addItem(item)
            DialogWidget.contact_box.setItemWidget(item, contact)
        
    
    @staticmethod        
    def set_all_as_offline():
        for key in DialogWidget.contactWidgetDic:
            contact = DialogWidget.contactWidgetDic[key]
            contact.set_as_offline()
    @staticmethod            
    def set_friend_online(uid,online):
        contact = DialogWidget.contactWidgetDic[uid]
        if online:
            contact.set_as_online()
        else:
            contact.set_as_offline()
        
    def online_refreshed(self):
        vk_api.vk.get_friends_online(vk_api.vk.myid)
        DialogWidget.fill_contactbox()
    @staticmethod                
    def fill_contactbox():
        selected_row = DialogWidget.contact_box.currentRow()
        for index in xrange(DialogWidget.contact_box.count()):
            DialogWidget.contact_box.setRowHidden(index, True)
        
        if DialogWidget.allRb.isChecked():
            target_dic = 'all'
        if DialogWidget.onlineRb.isChecked():
            target_dic = 'online'
        if DialogWidget.unreadRb.isChecked():
            target_dic = 'unread'
            DialogWidget.filterText.clear()
        filter = unicode(DialogWidget.filterText.text())
        filter_on = False
        if filter != "":
            filter_on = True
            filter = filter.lower()
        for index in xrange(DialogWidget.contact_box.count()):
            item = DialogWidget.contact_box.item(index)
            contact = DialogWidget.contact_box.itemWidget(item)
            id = contact.id
            online = id in vk_api.vk.friends_online
            if online:
                contact.set_as_online()
            else:
                contact.set_as_offline()
            if target_dic=='online':
                if not online: 
                    continue
            if target_dic=='unread':
                if not contact.unread>0:
                    continue
            if not filter_on:
                DialogWidget.contact_box.setRowHidden(index, False)
            else:
                name = contact.name.lower()
                if name.find(filter) == -1:
                    continue
                DialogWidget.contact_box.setRowHidden(index, False)
            
            
    def add_message_to_msg_list(self,message):
        pass
    
    @staticmethod
    def refresh_msg_list():
        key = DialogWidget.current_key
        DialogWidget.message_list.clear() 
        contact = DialogWidget.contactWidgetDic[key]
        contact.load_messages()
        count  = len(contact.messages)-1
        color = QColor('lightGray')
        if not contact.allMsgLoaded:
            widget = QWidget()
            hbox = QHBoxLayout()
            doLoadB = QPushButton(u'Загрузить более старые')
            doLoadB.clicked.connect(DialogWidget.dialog.old_load)
            doLoadB.setFixedHeight(70)
            hbox.addWidget(doLoadB)
            widget.setLayout(hbox)
            item = QListWidgetItem()
            item.setSizeHint(widget.sizeHint())
            DialogWidget.message_list.addItem(item)
            DialogWidget.message_list.setItemWidget(item, widget)
        for i in range(0,count+1):
            message = contact.messages[count-i]
            msg = MessageWidget(None, message)
            item = QListWidgetItem()
            item.setSizeHint(msg.sizeHint())
            if message.author == contact.name:
                item.setBackgroundColor(color)
            DialogWidget.message_list.addItem(item)
            DialogWidget.message_list.setItemWidget(item, msg)
        DialogWidget.message_list.scrollToBottom()
        
    def keyPressEvent(self, event):
        key = event.key()
        if key == 16777220 :
            self.send_message()
     
            
           
    def friend_changed(self):
        item = DialogWidget.contact_box.itemWidget(DialogWidget.contact_box.currentItem())
        DialogWidget.current_key = item.id
        DialogWidget.refresh_msg_list()
        self.contact = DialogWidget.contactWidgetDic[item.id]
        if self.contact.unread>0:
            self.contact.reset_unread()
    
    def __icon_activated(self, reason):
        if reason == QSystemTrayIcon.DoubleClick:
            self.app_expand()
            
    def closeEvent(self, event):
        self.hide()
        self.trayIcon.show() #thanks @mojo
        if ContactWidget.totalUnread>0:
            self.trayIcon.setIcon(QIcon(settings.images_path+"icon-mini_unread.png"))
        else:
            self.trayIcon.setIcon(QIcon(settings.images_path+"icon-mini.png"))
        self.showed = False
        sound_notifier.mixer_close()
        event.ignore()
        
    def send_message(self):
        userid = DialogWidget.current_key
        if userid == -1:
            return False
        message_text = unicode(DialogWidget.input_text.text())
        message_text = message_text
        if message_text == '':
            return False
        id = vk_api.vk.send_message(str(userid), message_text.encode('utf-8'))
        strid = str(id).encode("utf-8")
        author = u'Я'
        message = strid+"|"+author+" - "+message_text
        DialogWidget.contactWidgetDic[userid].add_message(message)
        DialogWidget.refresh_msg_list()
        self.input_text.clear()
    
    def app_exit(self):
        os.remove(settings.lockpath)
        sys.exit(app)
    
    def app_expand(self):
        self.trayIcon.hide()
        self.show()
        self.showed=True
        
    def openFullMessage(self):
        item = DialogWidget.message_list.itemWidget(DialogWidget.message_list.currentItem())
        mid = item.id
        atv = AttachViewer(None,mid)
        atv.exec_()
        
    def logout(self):
        print "LogOut"
        try:
            os.remove(settings.tokenpath)
        except:
            pass
        os.remove(settings.lockpath)
        sys.exit(app)
    def sound_setting_call(self):
        dialog = settingsDialog.settingsDialog()
        dialog.exec_()
        
    def set_mute(self):
        if sound_notifier.SoundNotifier.mute:
            self.muteButton.setIcon(DialogWidget.noMuteIcon)
            sound_notifier.SoundNotifier.mute = False
            self.muteAct.setIcon(DialogWidget.noMuteIcon)
            self.muteAct.setText(u'&Беззвучный режим ВЫКЛ')
        else:
            self.muteButton.setIcon(DialogWidget.muteIcon)
            sound_notifier.SoundNotifier.mute = True
            self.muteAct.setIcon(DialogWidget.muteIcon)
            self.muteAct.setText(u'&Беззвучный режим ВКЛ')
            sound_notifier.mixer_close()
            
    def change_visible_status(self):
        if self.soThread.online:
            self.soThread.online = False
            self.inviseButton.setIcon(QIcon(settings.images_path+'invisible.png'))
            open(settings.invisepath,'w').close()
        else:
            self.soThread.online = True
            self.inviseButton.setIcon(QIcon(settings.images_path+'visible.png'))
            os.remove(settings.invisepath)
            
            
    def subscribe_public(self):
        data_dic ={
                   'user_id':vk_api.vk.myid,
                   'group_id':str(settings.group_id)
                   }
        params = vk_api.vk.send_to_api('groups.isMember', data_dic)
        try:
            res = params['response']
            if res==1:
                return
        except:
            return
        reply = QMessageBox.question(None, u'Сообщение',
            u"Вы не подписаны на паблик приложения ВКонтакте. Там вы узнаете об обновлениях и новых функциях! Хотите подписаться?", QMessageBox.Yes | 
            QMessageBox.No, QMessageBox.No)

        if reply == QMessageBox.Yes:
            data_dic ={
                   'group_id':str(settings.group_id)
                   }
            params = vk_api.vk.send_to_api('groups.join', data_dic)
            print params
            pass
            
        else:
            return     
           
    def showAbout(self):
        about = AboutW()
        about.exec_() 
    def change_interface_mode(self):
        if self.logOutButton.isVisible():
            self.expandButton.setVisible(True)
            self.logOutButton.setVisible(False)
            self.soundSettingsButton.setVisible(False)
            self.aboutB.setVisible(False)
            self.closeAppButton.setVisible(False)
            self.muteButton.setVisible(False)
            self.contact_box.setVisible(False)
            DialogWidget.allRb.setVisible(False)
            DialogWidget.onlineRb.setVisible(False)
            DialogWidget.unreadRb.setVisible(False)
            DialogWidget.contact_box.setVisible(False)
            DialogWidget.filterText.setVisible(False)
            self.hideButton.setVisible(False)
            self.filterLabel.setVisible(False)
            self.allpic.setVisible(False)
            self.unreadpic.setVisible(False)
            self.onlinepic.setVisible(False)
            self.clearFilterButton.setVisible(False)
            self.inviseButton.setVisible(False)
            self.dialog_mode = 'compact'
        else:
            self.hideButton.setVisible(True)
            self.inviseButton.setVisible(True)
            self.logOutButton.setVisible(True)
            self.clearFilterButton.setVisible(True)
            self.soundSettingsButton.setVisible(True)
            self.aboutB.setVisible(True)
            self.closeAppButton.setVisible(True)
            self.muteButton.setVisible(True)
            self.contact_box.setVisible(True)
            DialogWidget.allRb.setVisible(True)
            DialogWidget.onlineRb.setVisible(True)
            DialogWidget.unreadRb.setVisible(True)
            DialogWidget.contact_box.setVisible(True)
            DialogWidget.filterText.setVisible(True)
            self.filterLabel.setVisible(True)
            self.allpic.setVisible(True)
            self.unreadpic.setVisible(True)
            self.onlinepic.setVisible(True)
            self.expandButton.setVisible(False)
            self.dialog_mode = 'adv'
            
    def get_left_panel(self):
        vbox = QVBoxLayout()
        hboxToolbar = QHBoxLayout()
        self.logOutButton = QPushButton()
        self.logOutButton.setIcon(QIcon(settings.images_path+'logout.png'))
        self.soundSettingsButton = QPushButton()
        self.soundSettingsButton.setIcon(QIcon(settings.images_path+'sound_settings.png'))
        self.aboutB = QPushButton()
        self.aboutB.setIcon(QIcon(settings.images_path+'info.png'))
        self.closeAppButton = QPushButton()
        self.closeAppButton.setIcon(QIcon(settings.images_path+'close_app.png'))
        self.hideButton = QPushButton()
        self.hideButton.setIcon(QIcon(settings.images_path+'compact_mode.png'))
        self.inviseButton = QPushButton()
        
        
        self.muteButton = QPushButton()
        if sound_notifier.SoundNotifier.mute:
            self.muteButton.setIcon(DialogWidget.muteIcon)
        else:
            self.muteButton.setIcon(DialogWidget.noMuteIcon)
        
        hboxToolbar.addWidget(self.closeAppButton)
        hboxToolbar.addWidget(self.logOutButton)
        hboxToolbar.addWidget(self.soundSettingsButton)
        hboxToolbar.addWidget(self.muteButton)
        hboxToolbar.addWidget(self.hideButton)
        hboxToolbar.addWidget(self.inviseButton)
        hboxToolbar.addWidget(self.aboutB)
        vbox.addLayout(hboxToolbar)
        
        self.inviseButton.setToolTip(u'Режим невидимости ВКЛ/ВЫКЛ(значение сохраняется после выхода из приложения)')
        self.logOutButton.setToolTip(u'Выйти из ВКонтакте и программы(запросит пароль и логин при следующем запуске)')
        self.soundSettingsButton.setToolTip(u'Настройки звука(Ctrl+O)')
        self.muteButton.setToolTip(u'Включить\Отключить беззвучный режим(Ctrl+M)')
        self.closeAppButton.setToolTip(u'Выйти только из приложения(Ctrl+Q)')
        self.hideButton.setToolTip(u'Только сообщения(Ctrl+D)')
        hboxFilter = QHBoxLayout()
        self.filterLabel = QLabel()
        self.filterLabel.setFixedWidth(40)
        self.filterLabel.setPixmap(QPixmap(settings.images_path+'filter.png'))
        
        hboxFilter.addWidget(self.filterLabel)
        hboxFilter.addWidget(DialogWidget.filterText)
        self.clearFilterButton = QPushButton(u'Очистить')
        self.clearFilterButton.setFixedWidth(70)
        DialogWidget.filterText.setFixedWidth(305-70)
        hboxFilter.addWidget(self.clearFilterButton)
        
        vbox.addLayout(hboxFilter)
        hboxRadio = QHBoxLayout()
        
        self.onlinepic = QLabel()
        self.onlinepic.setPixmap(QPixmap(settings.images_path+'online.png'))
        self.onlinepic.setFixedWidth(30)
        hboxRadio.addWidget(self.onlinepic)
        hboxRadio.addWidget(DialogWidget.onlineRb)
        
        
        self.allpic = QLabel()
        self.allpic.setPixmap(QPixmap(settings.images_path+'all.png'))
        self.allpic.setFixedWidth(30)
        hboxRadio.addWidget(self.allpic)
        hboxRadio.addWidget(DialogWidget.allRb)
        hboxUn = QHBoxLayout()
        
        vbox.addLayout(hboxUn)
        
        self.unreadpic = QLabel()
        self.unreadpic.setPixmap(QPixmap(settings.images_path+'unread_msg.png'))
        self.unreadpic.setFixedWidth(50)
        hboxUn.addWidget(self.unreadpic)
        hboxUn.addWidget(DialogWidget.unreadRb)
        
        vbox.addLayout(hboxRadio)
        
        self.init_contacts()
        vbox.addWidget(DialogWidget.contact_box)
        
        DialogWidget.contact_box.setFixedWidth(350)
        return vbox
           
    def __init__(self, parent=None):
        '''
        Constructor
        '''
        DialogWidget.dialog = self
        self.dialog_mode = 'adv'
        sound_notifier.SoundNotifier.initSounds()
        sound_notifier.SoundNotifier.openProgNotify()
        self.thread = DialogThread()
        self.thread_online = OnlineRefreshThread()
        QWidget.__init__(self, parent)
        self.setSizePolicy(QSizePolicy.Expanding,QSizePolicy.Expanding)
        self.showed = True    
        self.subscribe_public()
        self.trayIcon = QSystemTrayIcon(QIcon(settings.images_path+"icon-mini.png"),None)
        self.trayIcon.activated.connect(self.__icon_activated)
        self.trayIcon.setToolTip(u'Непрочитанных сообщений '+str(ContactWidget.totalUnread))
        exit_in_trmenu = QAction(QIcon(settings.images_path+"exit.jpg"),u"&Выход",self)
        expand_in_trmenu = QAction(QIcon(settings.images_path+"expand.png"),u"&Показать",self)
        #Pal = self.palette()
        #Pal.setColor(self.backgroundRole(), QColor('black'))
        #self.setAutoFillBackground(True);
        #self.setPalette(Pal);
        if sound_notifier.SoundNotifier.mute:
            self.muteAct = QAction(DialogWidget.muteIcon,u'&Беззвучный режим ВКЛ',self)
        else:
            self.muteAct = QAction(DialogWidget.noMuteIcon,u'&Беззвучный режим ВЫКЛ',self)
        
        self.muteAct.triggered.connect(self.set_mute)
        expand_in_trmenu.triggered.connect(self.app_expand)
        exit_in_trmenu.triggered.connect(self.app_exit)
        self.traymenu = QMenu(None)
        self.traymenu.addAction(expand_in_trmenu)
        self.traymenu.addAction(self.muteAct)
        self.traymenu.addAction(exit_in_trmenu)
        self.trayIcon.setContextMenu(self.traymenu)
        self.thread_online.onlineStatusUpdated.connect(self.online_refreshed)
        self.thread.haveUnreadSignal.connect(self.have_unread_slot)
        self.thread.start()
        self.thread_online.start()
        DialogWidget.onlineRb.setChecked(True)
        hbox = QHBoxLayout()
        mostVBOX = QVBoxLayout()
        mostVBOX.addLayout(hbox)
        secondhbox = QHBoxLayout()
        secondhbox.addWidget(DialogWidget.input_text)
        secondhbox.addWidget(DialogWidget.send_button)
        mostVBOX.addLayout(secondhbox)
        self.messages_layout = QVBoxLayout()
        vbox = self.get_left_panel()
        vbox_adv = QVBoxLayout()
        self.expandButton = QPushButton()
        vbox_adv.addWidget(self.expandButton)
        self.expandButton.setToolTip(u'Вернуться в обычный режим(Ctrl+D)')
        self.expandButton.setSizePolicy(QSizePolicy.Expanding, QSizePolicy.Expanding);
        self.expandButton.setFixedWidth(20)
        self.expandButton.setVisible(False)
        self.expandButton.setIcon(QIcon(settings.images_path+'lr_expand.png'))
        self.expandButton.clicked.connect(self.change_interface_mode)
        self.hideButton.clicked.connect(self.change_interface_mode)
        self.clearFilterButton.clicked.connect(self.filterText.clear)
        
        vbox2 = QVBoxLayout()
        hbox.addLayout(vbox)
        hbox.addLayout(vbox_adv)
        hbox.addLayout(vbox2)
        self.setLayout(mostVBOX)
        vbox2.addWidget(DialogWidget.message_list)
        DialogWidget.fill_contactbox()
        self.muteButton.clicked.connect(self.set_mute)
        self.logOutButton.clicked.connect(self.logout)
        self.aboutB.clicked.connect(self.showAbout)
        self.inviseButton.clicked.connect(self.change_visible_status)
        self.soundSettingsButton.clicked.connect(self.sound_setting_call)
        self.closeAppButton.clicked.connect(self.app_exit)
        self.soThread = SetOnlineThread()
        if not os.path.isfile(settings.invisepath):
            self.soThread.online = True
            self.inviseButton.setIcon(QIcon(settings.images_path+'visible.png'))
        else:
            self.soThread.online = False
            self.inviseButton.setIcon(QIcon(settings.images_path+'invisible.png'))
        self.soThread.start()
            
        QShortcut(QKeySequence("Ctrl+Q"), self, self.app_exit)
        QShortcut(QKeySequence(u"Ctrl+Й"), self, self.app_exit)
        
        QShortcut(QKeySequence("Ctrl+M"), self, self.set_mute)
        QShortcut(QKeySequence(u"Ctrl+Ь"), self, self.set_mute)
        
        QShortcut(QKeySequence("Ctrl+D"), self, self.change_interface_mode)
        QShortcut(QKeySequence(u"Ctrl+В"), self, self.change_interface_mode)
        
        QShortcut(QKeySequence("Ctrl+O"), self, self.sound_setting_call)
        QShortcut(QKeySequence(u"Ctrl+Щ"), self, self.sound_setting_call)
        
        QShortcut(QKeySequence("Ctrl+I"), self, self.change_visible_status)
        QShortcut(QKeySequence(u"Ctrl+Ш"), self, self.change_visible_status)
        
        QShortcut(QKeySequence("F1"), self, self.showAbout)
        DialogWidget.contact_box.currentItemChanged.connect(self.friend_changed)
        DialogWidget.allRb.toggled.connect(DialogWidget.fill_contactbox)
        DialogWidget.unreadRb.toggled.connect(DialogWidget.fill_contactbox)
        DialogWidget.onlineRb.toggled.connect(DialogWidget.fill_contactbox)
        DialogWidget.send_button.clicked.connect(self.send_message)
        DialogWidget.filterText.textChanged.connect(DialogWidget.fill_contactbox)       
        DialogWidget.message_list.itemDoubleClicked.connect(self.openFullMessage) 
        DialogWidget.message_list.setMinimumWidth(400)
    
    def old_load(self):
        scroll = DialogWidget.message_list.verticalScrollBar()
        if self.contact.allMsgLoaded:
            return
        self.contact.load_old_messages(DialogWidget.message_list.count())
        DialogWidget.refresh_msg_list()
        scroll.setValue(self.contact.old_loaded)
        DialogWidget.message_list.setCurrentRow(self.contact.old_loaded)
                
                
                
                






